# This file was *autogenerated* from the file solve_sos_polynomial_new.sage.
from sage.all_cmdline import *   # import sage library
_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_1en7 = RealNumber('1e-7'); _sage_const_1e8 = RealNumber('1e8')
execfile("quadratic_forms.py")
execfile("sdp_solver.py")
execfile("linear_algebra.py")

### Polynomials
indeterminates=['x', 'y', 'z']
polynomial_ring=PolynomialRing(QQ, indeterminates)

monomial_list=[polynomial_ring('x')**a * polynomial_ring('y')**b * polynomial_ring('z')**c for a in range(_sage_const_3 ) for b in range(_sage_const_3 ) for c in range(_sage_const_3 ) if a+b+c<=_sage_const_2 ]

lhs_polynomials=[polynomial_ring(p) for p in ['1']]
lhs_monomial_lists=[monomial_list for p in lhs_polynomials]
assert len(lhs_polynomials) == len(lhs_monomial_lists)

rhs_polynomial=polynomial_ring('3/4*(551*x^2+3*y^2+z)^2+2*(551*x^2+3*y^2+z)+5')
#rhs_polynomial=polynomial_ring('3/4*(551*x^2+3*y^2+z)^2+2*(551*x^2+3*y^2+z)+5+(23*x+13*y+z)^2')
# rhs_polynomial=polynomial_ring('3/4*(x+3*y^2+z)^2+2*(x+3*y^2+z)+5')
#rhs_polynomial=polynomial_ring('3/4*(x+3*y^2+z)^2+2*(x+3*y^2+z)+5+(1+x+y+z)^2')


def coeff_name(block, i, j):
  if i<j:
    k=i
    i=j
    j=k
  return "mat_%d_%d_%d" %(block, i, j)

coeff_positions=[(block, i, j)\
             for block in xrange(len(lhs_monomial_lists))\
             for i in xrange(len(lhs_monomial_lists[block]))\
             for j in xrange(i+_sage_const_1 )]
coeff_positions_rev = dict([(coeff_positions[k], k) for k in xrange(len(coeff_positions))])

coeff_names=[coeff_name(block, i, j) for (block, i, j) in coeff_positions]

def get_coeff_position(block, i, j):
  if i < j:
    return coeff_positions_rev[(block, j, i)]
  else:
    return coeff_positions_rev[(block, i, j)]

def vector_to_blocks(v):
  blocks = [matrix(QQ, len(block), sparse=True) for block in lhs_monomial_lists]
  for k in v.nonzero_positions():
    (block, i, j)=coeff_positions[k]
    blocks[block][i,j] = blocks[block][j,i] = v[k]
  return blocks

def polynomial_from_blocks(blocks):
  total = polynomial_ring(_sage_const_0 )
  for i in xrange(len(lhs_polynomials)):
    total += apply_qmatrix(blocks[i], vector(lhs_monomial_lists[i])) * lhs_polynomials[i]
  return total

def apply_solution(solution, zf0b, zfisb):
  assert len(solution) == len(zfisb)
  result = copy(zf0b)
  for block in xrange(len(result)):
    for i in xrange(len(solution)):
      result[block] += solution[i] * zfisb[i][block]
  return result

# Sun Oct 11 22:04:35 CEST 2009 cervin
# 0.77 s/tour + 1s lancement

constraint_space = VectorSpace(QQ, len(coeff_names)+_sage_const_1 , sparse=True)
for numero_essai in range(_sage_const_1 ):

  constraint_map = {}
  for (exponents_t, scalar) in rhs_polynomial.dict().iteritems():
    exponents = tuple(exponents_t)
    v=constraint_space(_sage_const_0 )
    v[len(v)-_sage_const_1 ]=-scalar
    constraint_map[exponents]=v

  for block in xrange(len(lhs_polynomials)):
    monomials = lhs_monomial_lists[block]
    for i in xrange(len(monomials)):
      for j in xrange(len(monomials)):
        k=get_coeff_position(block, i, j)
        for (exponents_t, coeff) in (monomials[i]*monomials[j]*lhs_polynomials[block]).dict().iteritems():
          exponents=tuple(exponents_t)
          if not constraint_map.has_key(exponents):
            constraint_map[exponents]=constraint_space(_sage_const_0 )
          constraint_map[exponents][k] += coeff

  constraint_matrix = Matrix(QQ, constraint_map.values(), sparse=True)
  iteration_count = _sage_const_0
  has_solution=True

  while has_solution:
    iteration_count += _sage_const_1

    print "iteration count:", iteration_count
    constraint_solution = right_kernel_basis(constraint_matrix)
    fis=[]
    f0=()
    for row in constraint_solution:
      if row[len(row)-_sage_const_1 ]==_sage_const_0 :
        fis.append(row[_sage_const_0 :len(row)-_sage_const_1 ])
      else:
        if f0==():
          f0=row[_sage_const_0 :len(row)-_sage_const_1 ]/row[len(row)-_sage_const_1 ]
        else:
          assert false

    print "dimension of search space:", len(fis)

    assert polynomial_from_blocks(vector_to_blocks(f0))==rhs_polynomial
    for fi in fis:
      assert polynomial_from_blocks(vector_to_blocks(f0+fi))==rhs_polynomial

    f0b = vector_to_blocks(f0)
    fisb = map(vector_to_blocks, fis)

    if len(fisb)==_sage_const_0 :
      solution=[]
      solution_q=[]
      for m in f0b:
        if not is_positive_semidefinite(m):
          has_solution=False
      break

    positive_ms = [() for i in f0b]
    f0b2 = [() for m in f0b]
    fisb2 = [ [() for m in fib] for fib in fisb]

    for block in xrange(len(f0b)):
      # vectors in kernels for all matrices are in final kernel
      compound = f0b[block].rows()
      for fib in fisb:
        compound += fib[block].rows()

      kernel_basis = right_kernel_basis(matrix(compound,sparse=True))
      if len(kernel_basis) > _sage_const_0 :
        positive_ms[block]=Matrix(QQ,right_kernel_basis(Matrix(QQ, kernel_basis)))
      else:
        positive_ms[block]=identity_matrix(f0b[block].nrows())

      f0b2[block] = positive_ms[block] * f0b[block] * positive_ms[block].transpose()
      for i in xrange(len(fisb)):
        fisb2[i][block] = positive_ms[block] * fisb[i][block] * positive_ms[block].transpose()

    solution=sdp_solve("sosproblem-%02d"%iteration_count, [-m for m in f0b2], fisb2, [_sage_const_0  for fib2 in fisb2])

    solution_q=vector(QQ,solution)

    qblocks2=apply_solution(solution_q, f0b2, fisb2)
    numblocks2=apply_solution(solution, f0b2, fisb2)

    found_new_kernel_vector=False
    for block in xrange(len(f0b)):
      if not is_positive_semidefinite(qblocks2[block]):
        # print "eigenvalues:", numblocks2[block].eigenvalues()
        found_new_kernel_vector=True
        if len(solution_q)==_sage_const_0 :
          has_solution=False
          break

        scale_factor=_sage_const_1e8  #tune
        o=numblocks2[block]
        olat=Matrix((o*scale_factor).rows() + identity_matrix(o.ncols()).rows())
        #kernel_vector2=pari(olat).qflll().python().column(0)
        red=olat.transpose().apply_map(round,ZZ).LLL()[_sage_const_0 :o.nrows(),o.nrows():olat.nrows()]

        kernel_constraints = []
        for knumber in xrange(red.nrows()):
          kernel_vector2=red.row(knumber)
          kernel_vector=positive_ms[block].transpose() * kernel_vector2
          eps=(o*kernel_vector2).norm()/n(kernel_vector2.norm())

          if eps>_sage_const_1en7 :
            break

          print "kernel vector:", kernel_vector, 'eps:', eps

          dim = f0b[block].nrows()
          for i in xrange(dim):
            constraint=constraint_space(_sage_const_0 )
            for j in xrange(dim):
              constraint[get_coeff_position(block, i, j)] = kernel_vector[j]
              kernel_constraints.append(constraint)

        if len(kernel_constraints) > _sage_const_0 :
          constraint_matrix = constraint_matrix.stack(Matrix(QQ, kernel_constraints, sparse=True))

    if not found_new_kernel_vector:
      break

  if has_solution:
    matrices=apply_solution(solution_q, f0b, fisb)

    total=polynomial_ring(_sage_const_0 )
    for block in xrange(len(lhs_polynomials)):
      sos=polynomial_ring(_sage_const_0 )
      for (coeff, v) in sdp_matrix_to_sos(matrices[block]):
        sos += coeff * (v*vector(lhs_monomial_lists[block]))**_sage_const_2
      total += lhs_polynomials[block] * sos

    print "SOLUTION IS CORRECT:", total == rhs_polynomial

    total=SR(_sage_const_0 )
    for block in xrange(len(lhs_polynomials)):
      sos=SR(_sage_const_0 )
      for (coeff, v) in sdp_matrix_to_sos(matrices[block]):
        sos += coeff * (v*vector(lhs_monomial_lists[block]))**_sage_const_2
      total += lhs_polynomials[block] * sos

  else:
    print "NO SOLUTION"

